/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ead.poligonoprogetto;

import java.awt.Polygon;
import java.awt.geom.Point2D;

/**
 *
 * @author Renato
 */
// Classe che eredita da java.awt.Polygon (che implementa l'interfaccia Shape)
public class PoligonoEr extends Polygon {

    // Costruttore non necessario ma per eventuali usi futuri 
    public PoligonoEr() {
        super();

    }

    // Calcolo del perimetro
    public double perimetro() {
        double perim = 0;
        if (npoints > 0) {
            for (int i = 0; i < npoints - 1; i++) {
                perim = perim + Point2D.Double.distance(xpoints[i], ypoints[i], xpoints[i + 1], ypoints[i + 1]);
            }
            perim = perim + Point2D.Double.distance(xpoints[npoints - 1], ypoints[npoints - 1], xpoints[0], ypoints[0]);
        }
        return perim;

    }

    // Calcolo dell'area
    public double area() {
        double a = 0;
        if (npoints > 0) {
            for (int i = 0; i < npoints - 1; i++) {
                a = a + xpoints[i] * ypoints[i + 1] - ypoints[i] * xpoints[i + 1];

            }
            a = a + xpoints[npoints - 1] * ypoints[0] - ypoints[npoints - 1] * xpoints[0];
        }
        return 0.5 * Math.abs(a);

    }

    // Restituzione del numero di vertici
    public int size() {
        return npoints;

    }

}
